import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;


/** Servlet Eingabe eines einzelnen Artikels
  * @author Bernhard Fiser 0109815
  */
public class ArtikelDetailServlet extends HttpServlet
{
	private static ArtikelVerwaltung
			av;
	private Artikel	a;


	/** Beim Laden des Servlets einmal instanzieren */
	public void init()
	{
		av = ArtikelVerwaltung.getInstance();
	}

	/** CGI-POST Methode, wird auf die CGI-GET Methode weitergeleitet */
	public void doPost(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
	{
		this.doGet(request, response);
	}

	/** CGI-GET Methode, hier findet gesamte Verarbeitung statt */
	public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
	{
		Art		art;
		Iterator	i;
		String		id,
				selected;

		/* Contenttype der HTML-Seite setzen */
		response.setContentType("text/html");
		/* outputhandle erstellen */
		PrintWriter out = response.getWriter();
		/* HTML Seite beginnen */
		out.println(
			"<html><head><meta name=\"author\" content=\"Bernhard Fiser\">" +
			"<meta name=\"date\" content=\"2002-05-14T08:29:56+02:00\">" +
			"<title>Artikelverwaltung:Artikeldetails - Bernhard Fiser 0109815</title></head>" +
			"<body bgcolor=\"#ffffff\">\n<form method=\"post\" action=\"ArtikelVerwaltungServlet\">");

		/* CGI-Parameter 'cgi_id' aus FORM bernehmen... */
		id = request.getParameter("cgi_id");
		/* ... und falls dieser vorhanden .. */
		if ((id == null) || (id.length() < 3))
			id = "";

		/* Artikel aus Datei lesen */
		this.init();
		/* neue Artikel erzeugen, falls keine sinnvolle ID vorhanden ist */
		if ((a = (Artikel) av.get(id.toLowerCase())) == null)
			a = new Artikel((Art) av.getArten().get("bo"));

		/* Tabelle mit Inputfelder erstellen, und defaultwerte Eintragen */
		out.println("<table border=\"0\">");
		out.println("<tr><td>ID:</td><td><input type=\"text\" name=\"cgi_id\" value=\"" + a.getIDn() + "\" size=\"3\"></td>");
		out.println("<tr><td>Bezeichnung:</td><td><input type=\"text\" name=\"cgi_desc\" value=\"" + a.getDescription() + "\" size=\"30\"></td>");
		out.println("<tr><td>Art:</td><td><select name=\"cgi_art\">");

		/* Iteration ber alle Arten um ein popup (select) zu erstellen */
		i = av.getArten().values().iterator();
		while (i.hasNext())
		{
			art = (Art) i.next();

			/* falls der Artikel zu dieser Art gehrt, dann diesen Parameter vom select auswhlen */
			if (art.getDescription().compareToIgnoreCase(a.getArt().getDescription()) == 0)
				selected = " selected";
			else
				selected = "";

			out.print("<option value=\"" + art.getID() + "\"" + selected + ">" + art.getDescription());
		}

		out.println("</select></td>");
		out.println("</table><hr><input type=\"submit\" name=\"cgi_save\" value=\"Speichern\">");
		out.println("<input type=\"submit\" name=\"cgi_list\" value=\"Zur&uuml;ck\">");
		out.println("</body></html>\n");
	}
}
